﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;
using RelayResponse;

namespace RelayResponse.Example.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            return View();
        }

        /// <summary>
        /// Makes a GET request to a URL and returns the relayed result.
        /// </summary>
        private HttpWebResponseResult ExternalGet(string url)
        {
            var getRequest = (HttpWebRequest)WebRequest.Create(url);
            var getResponse = (HttpWebResponse)getRequest.GetResponse();

            return new HttpWebResponseResult(getResponse);
        }

        public HttpWebResponseResult RelayHtml()
        {
            return ExternalGet("http://web.archive.org/web/19961220154510/http://www.yahoo.com/");
        }

        public HttpWebResponseResult RelayJavascript()
        {
            return ExternalGet("http://www.google-analytics.com/ga.js");
        }

        public HttpWebResponseResult RelayImage()
        {
            return ExternalGet("http://www.gregwilson.co.uk/wp-content/uploads/2012/06/Parliament-Mothership-Connection.jpg");
        }

        public HttpWebResponseResult RelayDownload()
        {
            return ExternalGet("http://github.com/douglascrockford/JSON-js/zipball/master");
        }

        [HttpPost]
        public HttpWebResponseResult RelayPost()
        {
            var postRequest = (HttpWebRequest)WebRequest.Create("http://www.fissio.com/pirate.pl");
            postRequest.Method = "POST";

            // Relay content stream
            this.Request.InputStream.CopyTo(postRequest.GetRequestStream());

            var response = (HttpWebResponse)postRequest.GetResponse();

            return new HttpWebResponseResult(response);
        }
    }
}
